#ifndef _LEVEL_H_
#define _LEVEL_H_

//Header file containing level structures, function declarations and level specific definitions.

#include <header.h>
#include <attr.h>
#include <ascii.h>

//Types of Level Layers
#define LEVEL_NULL -1

//Level Layer Map
struct _level{
	int nlayers;
	int *layertypes;
	int *layers; //Void Pointers.
	attrmap *am; //Easy Access.
};

typedef struct _level level;

//Unload Level
void unload_level(level *givlevel);

//Create Level
level *create_level(int nlayers);

//Load Level from a file
level *load_level(char *levelname);

//Unload all Levels
void unload_levels();

//Load all Levels
int load_levels();

#endif //_LEVEL_H_