//Source file for Player

#include <gameglobal.h>
#include <player.h>
#include <camera.h>

#define JMPHEIGHT 32
#define SPC 32

int jumpup=0,jumpvel=0;
int dropheight=0;
int reachedeng=0;

//Player DropHeight Collision
void calctrainpos(){
	int i;
	int oldwidth=0,width=0;

	int relx=playerx-trainx;	

	int *traindata=am->traindata;
	int ntrains=am->ntrains;

	dropheight=trainy;

	for(i=0;i<ntrains;++i) {

		//Coach 
		if(traindata[i]==SPR_COACH) {
			width+=(aacoach->width-2)*xmul;
			if(relx>=oldwidth&&relx<=width) return;

			width+=(aaconnector->width)*xmul;
			if(relx>=oldwidth&&relx<=width)
				{dropheight+=(3*ymul); return;}			

			width+=xmul;
		}
		//The Narrow Coach
		else if(traindata[i]==SPR_COACH2) {
			width+=(aacoach2->width-4)*xmul;
			if(relx>=oldwidth&&relx<=width)
				{dropheight+=(2*ymul); return;}

			oldwidth=width;	width+=(2*xmul);

			if(relx>=oldwidth&&relx<=width)
				return;		

			width+=(aaconnector->width)*xmul;
			if(relx>=oldwidth&&relx<=width)
				{dropheight+=(3*ymul); return;}

			width+=xmul;
		}
		//Coach 
		else if(traindata[i]==SPR_COACH3) {
			width+=(aacoach3->width-2)*xmul;
			if(relx>=oldwidth&&relx<=width) return;

			width+=(aaconnector->width)*xmul;
			if(relx>=oldwidth&&relx<=width)
				{dropheight+=(3*ymul); return;}

			width+=xmul;
		}
		//Engine. Also Do Reached Engine.
		else if(traindata[i]==SPR_ENGINE) {
			width+=(aaengine->width-2)*xmul;
			if(relx>=oldwidth+(4*xmul)) {
				dropheight+=(3*ymul); 
				if((playery-dropheight)<=(2*ymul))
					reachedeng++; 
				return;
			}
			else if(relx>=oldwidth&&relx<=width) {
				return;
			}
		}
		oldwidth=width;
	}
}

//Player Update
void update_player(){
	
	calctrainpos();	

	//Check for win/Lose
	if((playerx-camx+SPC)<=0) {++gamelost; return;}
	if(playerx<=trainx) {++gamelost; return;}
	if(reachedeng) {++levelwon; return;}

	//Jumping.
	if(jumpup) {
		jumpup--;
		playery--;
	}
	else if(playery<dropheight)
		playery++;
	else if(playery==dropheight&&playerstate!=PLAYER_CROUCH) 
		playerstate=PLAYER_STAND;
	else
		playery=dropheight;	
}

//Player UnInitialize
void player_uninitialize(int levelnum){
	//Set to Default
	player_stand();
	playerx=0;
	playery=0;
	dropheight=0;
	jumpup=0;	
	reachedeng=0;
}

//Player Initialize
void player_initialize(int levelnum){

	//Initialize Positions
	playerx=trainx+10; //Initially
	calctrainpos();	playery=dropheight;

	//Stand
	playerstate=PLAYER_STAND;

	//Not Reached Engine Yet
	reachedeng=0;
}

//Player Stand
void player_stand(){
	if(playerstate==PLAYER_JUMP) return;
	
	playerstate=PLAYER_STAND;
}

//Player Crouch
void player_crouch(){
	//Crouch (Apparently Useless)

	playerstate=PLAYER_CROUCH;	
}

//Player Jump
void player_jump(){	
	if(playerstate==PLAYER_JUMP) return;
	if(playerstate==PLAYER_CROUCH) { player_stand(); return; }

	//Set to Jump
	playerstate=PLAYER_JUMP; jumpup=JMPHEIGHT;
}

//Player Right
void player_right(){
	player_stand();
	playerx++;
	if((playerx-camx)>dbuffer->w/2)	camx=playerx-dbuffer->w/2;
	right_camera();
}